
#ifndef _LOAD_PARAM_H
#define _LOAD_PARAM_H

#include "factory.h"
#include "debug.h"

// abstract base class
class baseLoadParam
{
 public:
  //  virtual void Call(const char* string)=0;        // call using function
};


// derived template class
template<class T> class LoadParam : public baseLoadParam
{
 public:
  LoadParam(const TiXmlElement* root, const char* paramName, T* pt2Object, void(T::*function)(const char*))
    { 
      const char* loadString = grabParameter(root, paramName);
      if (loadString != NULL)
	(*pt2Object.*function)(loadString);
      else 
	PRINTF(2)("Not loaded parameter %s of %s\n", paramName, pt2Object->getClassName());
      
    };

  LoadParam(const TiXmlElement* root, const char* paramName, T* pt2Object, void(T::*function)(float))
    {
      const char* loadString = grabParameter(root, paramName);
      if (loadString != NULL)
	(*pt2Object.*function)(atoi(loadString));
      else 
	PRINTF(2)("Not loaded parameter %s of %s\n", paramName, pt2Object->getClassName());
    };
};


#endif /* _LOAD_PARAM_H */
